# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

def error_quit(problem_id, do_quit):
	messages = ['Sorry. Cannot load the modules needed by winki the ripper']
	if problem_id < len(messages):
		print messages[problem_id]
	else:
		print 'oops...'
	if do_quit != 0:
		raise SystemExit

try:
	print 'Importing module gtk...'
	import gtk

	print 'Importing module gnome...'
	import gnome

	print 'Importing module os...'
	import os

except:
	error_quit(0, 1)

class BasePage:
	def __init__(self, xml, app):
		self.xml = xml
		self.app = app
		return
		
	def check_widgets(self):
		return

	def on_prepare(self):
		print 'BasePage.on_prepare() not overwritten'
		return False

	def on_next(self):
		print 'BasePage.on_next() not overwritten'
		return False

	def on_prev(self):
		print 'BasePage.on_prev() not overwritten'
		return False

	def can_exit(self):
		print 'BasePage.can_exit() not overwritten'
		return False

	def update_project(self):
		print 'BasePage.update_project() not overwritten'
		return False

	def show_help(self, file_name = None):
		# temp: this is ugly workaround for gnome.help_display() not working for me
		# todo: use gnome.help_display()
		#gnome.help_display('winki', None)
		try:
			os.system('yelp ghelp:/usr/share/gnome/help/winki/C/winki.xml')
		except:
			pass
		# end temp
		return True

