# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

def error_quit(problem_id, do_quit):
	messages = ['Sorry. Cannot load the modules needed by winki the ripper']
	if problem_id < len(messages):
		print messages[problem_id]
	else:
		print 'oops...'
	if do_quit != 0:
		raise SystemExit

try:
	print 'Importing module gtk...'
	import gtk

	print 'Importing module winki.lib...'
	import winki.lib

	print 'Importing module winki.command...'
	import winki.command

except:
	error_quit(0, 1)

class BasePlayerPage:
	def __init__(self):
		self.mplayer = None
		return

	def on_next(self):
		if self.mplayer:
			return False

		return True

	def on_prev(self):
		if self.mplayer:
			return False

		return True

	def has_player(self):
		return (self.mplayer != None)

	def start_player(self, area, cmd, callback):
		XID = area.window.xid
		left, top, width, height = area.get_allocation()

		cmdStr = cmd % (XID, width, height)

		assert(self.mplayer == None)
		if self.mplayer:
			winki.lib.debug('BasePlayerPage.start_player()', 'mplayer instance still loaded in memory', winki.lib.error)
			return

		self.mplayer = winki.command.Command(cmdStr, callback)
		self.mplayer.run()
		return

	def stop_player(self):
		if not self.mplayer:
			winki.lib.debug('BasePlayerPage.stop_player()', 'no mplayer instance running')
			return

		self.mplayer.stop()
		self.mplayer = None
		return

	def on_forward_1(self):
		if not self.mplayer:
			winki.lib.debug('BasePlayerPage.on_forward_1()', 'no mplayer instance', winki.lib.error)
			return

		self.mplayer.to_stdin('seek 1\n')
		return

	def on_forward_10(self):
		if not self.mplayer:
			winki.lib.debug('BasePlayerPage.on_forward_10()', 'no mplayer instance', winki.lib.error)
			return

		self.mplayer.to_stdin('seek 10\n')
		return

	def on_forward_30(self):
		if not self.mplayer:
			winki.lib.debug('BasePlayerPage.on_forward_30()', 'no mplayer instance', winki.lib.error)
			return

		self.mplayer.to_stdin('seek 30\n')
		return

	def on_backward_1(self):
		if not self.mplayer:
			winki.lib.debug('BasePlayerPage.on_backward_1()', 'no mplayer instance', winki.lib.error)
			return

		self.mplayer.to_stdin('seek -2\n')
		return

	def on_backward_10(self):
		if not self.mplayer:
			winki.lib.debug('BasePlayerPage.on_backward_10()', 'no mplayer instance', winki.lib.error)
			return

		self.mplayer.to_stdin('seek -10\n')
		return

	def on_backward_30(self):
		if not self.mplayer:
			winki.lib.debug('BasePlayerPage.on_backward_30()', 'no mplayer instance', winki.lib.error)
			return

		self.mplayer.to_stdin('seek -30\n')
		return

