# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

def error_quit(problem_id, do_quit):
	messages = ['Sorry. Cannot load the modules needed by winki the ripper']
	if problem_id < len(messages):
		print messages[problem_id]
	else:
		print 'oops...'
	if do_quit != 0:
		raise SystemExit

try:
	print 'Importing module gtk...'
	import gtk

	print 'Importing module winki.lib...'
	import winki.lib

	print 'Importing module winki.base_page...'
	import winki.base_page

except:
	error_quit(0, 1)

class PageTitle(winki.base_page.BasePage):
	def __init__(self, xml, app):
		winki.base_page.BasePage.__init__(self, xml, app)
		self.no_titles = [_('No titles found on this DVD')]
		return
		
	def check_widgets(self):
		widgets = ['combo_dvd_title', 'label_dvd_title']

		winki.lib.check_widgets(self.xml, widgets)
		return

	def on_prepare(self):
		combo_dvd_title = self.xml.get_widget('combo_dvd_title')
		sel = self.app.project.get_current_title()
		winki.lib.fill_combo(combo_dvd_title, self.app.project.get_titles(), sel, self.no_titles)

		return True

	def on_next(self):
		combo_dvd_title = self.xml.get_widget('combo_dvd_title')
		text = combo_dvd_title.entry.get_text()
		index = winki.lib.get_index(self.app.project.get_titles(), text)
		if index == -1:
			winki.lib.debug('PageTitle.on_next()', 'no titles found', winki.lib.error)
			return False

		current = self.app.project.set_current_title(index)
		return (current == index)

	def on_prev(self):
		return True

	def can_exit(self):
		return True

	def show_help(self):
		return winki.base_page.BasePage.show_help(self, 'title.html')

	def title_changed(self):
		combo_dvd_title = self.xml.get_widget('combo_dvd_title')
		text = combo_dvd_title.entry.get_text()

		if text == self.no_titles[0] or not len(text):
			return True

		if not self.app.project.set_title(text):
			winki.lib.debug('PageTitle.title_changed()', 'internal error')
			return False

		return True

