# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

print 'Importing module winki.lib...'
import winki.lib

class RCVersion:
		def __init__(self):
			self.initial = {'Output directory' : '~/movie',
					 'Default source' : 'dvd',
					 'Default encoding' : 'multi pass',
					 'Default size' : '700',
					 'Preferred audio' : 'English',
					 'Preferred subtitles' : 'English',
					 'User mode' : 'Default',
					 'mplayer' : '', 
					 'mencoder' : '', 
					 'oggenc' : '', 
					 'ogmmerge' : '', 
					 'normalize' : '', 
					 'Audio compressor' : 'oggenc',
					 'Audio compressor options' : '-q 4',
					 'Audio compressor extension' : 'ogg',
					 'Stream merger' : 'ogmmerge',
					 'Video codec' : 'lavc',
					 'Video codec options' : '-lavcopts vcodec=mpeg4:vhq:vqmin=2:trell:autoaspect',
					 'Video filter' : 'crop=value,hqdn3d=2:1:2',
					 'Supplement' : '-mc 0',
					 'Default comment' : 'Created by MEncoder\'s frontend Winki the Ripper',
					 'Nice value' : '19',
					 'Lower threshold' : '700',
					 'Upper threshold' : '2000',
					 'Container penalty' : '0.015',
					 'Use warnings' : 'bitrate_high bitrate_low abort dest_dir',
					 'Bits per audio second' : '14000',
					 'Bits per subtitle second' : '3500',
					 'Preferred bitrate' : '800',
					 'Minimum bitrate' : '750'}

			self.versions = ['0.3', '0.3.1', '0.3.2', '0.3.3', '0.3.4', '0.3.5', '0.3.6', '0.3.7', '0.3.8']
			self.current = winki.lib.winki_version
			return

		def get_current(self):
			return self.get_version(self.current)

		def get_version(self, version):
			dic = None
			found = 0

			for v in self.versions:
				if version == v:
					found = 1
					break

			if not found:
				return dic

			return self.build_version(version)

		def build_version(self, version):

			i = 0
			dic = {}
			for key in self.initial:
					dic[key] = self.initial[key]

			cur = self.versions[i]
			
			while cur != version:
				i += 1
				cur = self.versions[i]
				self.modify_dic(cur, dic)

			return dic

		def modify_dic(self, version, dic):
			if version == '0.3':
				pass

			elif version == '0.3.1':
				dic['lsdvd'] = ''

			elif version == '0.3.2':
				dic['VCD type'] = 'PAL'
				dic['DVD device'] = '/dev/dvd'
				dic['CD-ROM device'] = '/dev/cdrom'
				dic['vcdimager'] = ''
				dic['dvb-mplex'] = ''
				dic['Multiplexer'] = 'dvb-mplex'
				dic['VCD codec'] = 'lavc'
				dic['VCD options'] = '-lavcopts vcodec=mpeg1video:keyint=12:aspect=4/3:mbd=2:acodec=mp2:abitrate=224:vbitrate=1152:vrc_buf_size=327:vrc_maxrate=1152'
				dic['VCD filter'] = 'crop=value,scale=value,expand=value'
				dic['SVCD codec'] = 'lavc'
				dic['SVCD options'] = '-lavcopts vcodec=mpeg2video:keyint=25:aspect=4/3:mbd=2:acodec=mp2:abitrate=128:vbitrate=value:vrc_buf_size=917:vrc_maxrate=2600'
				dic['SVCD filter'] = 'crop=value,scale=value,expand=value'
				dic['Video codec options'] = '-lavcopts vcodec=mpeg4:mbd=2:vqmin=2:trell:autoaspect'
				del dic['Bits per audio second']
				del dic['Bits per subtitle second']
				dic['Bytes per ogg second'] = '14000'
				dic['Bytes per mp2 second'] = '21500'
				dic['Bytes per subtitle second'] = '3500'
				dic['Bytes per VCD second'] = '144500'
				dic['SVCD container penalty'] = '0.14'
				dic['Use warnings'] = 'bitrate_high bitrate_low abort dest_dir mising_tools'
				del dic['Output directory']
				dic['Output folder'] = '~/movie'

			elif version == '0.3.3':
				pass

			elif version == '0.3.4':
				dic['Stream merger'] = 'mkvmerge'
				del dic['Container penalty']
				dic['OGM container penalty'] = '0.015'
				dic['Matroska container penalty'] = '0.005'
				del dic['Audio compressor options']
				del dic['Audio compressor extension']
				dic['Oggenc options'] = '-q 4'
				dic['Lame options'] = '--preset standard'
				dic['Bytes per mp3 second'] = '19500'
				pass

			elif version == '0.3.5':
				pass

			elif version == '0.3.6':
				pass

			elif version == '0.3.7':
				dic['Lower threshold'] = '800'
				dic['Upper threshold'] = '2500'
				dic['Preferred bitrate'] = '850'
				dic['Minimum bitrate'] = '800'
				pass

			elif version == '0.3.8':
				pass

			else:
				assert(0)

			return

