# Winki the Ripper - GTK frontend for mencoder, mplayer and lsdvd
# Copyright (C) 2004 Velko Hristov
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

def error_quit(problem_id, do_quit):
	messages = ['Sorry. Cannot load the modules needed by winki the ripper']
	if problem_id < len(messages):
		print messages[problem_id]
	else:
		print 'oops...'
	if do_quit != 0:
		raise SystemExit

try:
	print 'Importing module string...'
	import string

	print 'Importing module winki.command...'
	import winki.command

	print 'Importing module winki.lib...'
	import winki.lib

except:
	error_quit(0, 1)

class ToolFinder:
	def __init__(self):
		self.path = None
		return

	def get_tool(self, tool_name, meta_tools):
		if not self.has_tool(tool_name, meta_tools):
			return None
		return self.path

	def check_tools(self, tool_list, meta_tools):

		result = 1
		for tool in tool_list:
			if not self.has_tool(tool, meta_tools):
				result = 0
			
		return result

	def check_listed_tools(self, tool_list, tool_names, meta_tools, use_warning):
		assert(len(tool_list) == len(tool_names))
		result = 1

		for i in range(len(tool_list)):
			if not winki.lib.is_file(tool_list[i]) or not winki.lib.is_executable(tool_list[i]):
				tool = tool_names[i]
				tool_name = ''
				for meta_tool in meta_tools:
					if tool == meta_tool:
						lst = meta_tools[meta_tool]
						for l in range(len(lst)):
							tool_name += lst[l]
							if l < len(lst) - 1:
								tool_name += ' or '
				if not len(tool_name):
					tool_name = tool
				winki.lib.debug('ToolFinder.check_listed_tools()', 'The program "%s" mentioned in your ~/.winkirc could not be executed or does not exist' % tool_name, winki.lib.error)

				if use_warning:
					primary = _('Missing tool')
					secondary = _('Winki the Ripper could not find the program %s mentioned in your winkirc. Most likely the program will not operate correctly without it. Or you will miss some functionality.') % tool_name
					winki.lib.alert(primary, secondary, 'error')
				result &= 0

		return result

	def has_tool(self, tool_name, meta_tools):
		if not tool_name or not len(tool_name):
			return 0

		tool_names = []
		for meta_tool in meta_tools:
			if tool_name == meta_tool:
				tool_names = meta_tools[meta_tool]

			if not len(tool_names):
				tool_names = [tool_name]

		self.path = None

		for tool_name in tool_names:
			cmd = 'which %s' % tool_name
			command = winki.command.Command(cmd, self.get_name)
			command.bufsize = 5
			command.run()
			if command.result == 0:
				return 1

			print 'Could not find %s in the current path' % tool_name

		return 0

	def get_name(self, line):
		if not line or not len(line):
			return

		self.path = line
		return
		

